#!/usr/local/bin/perl
# index.cgi
# Display a list of run-levels and the actions that are run at boot and
# shutdown time for each level

require './inittab-lib.pl';
&ui_print_header(undef,  $text{'inittab_title'}, "", "index", 1, 1, 0,
	&help_search_link("inittab", "man"));

print "<a href=new_inittab.cgi>$text{'inittab_new'}</a><br>\n";
print &ui_columns_start([ &hlink( $text{ 'inittab_id' }, "id" ),
			  &hlink( $text{ 'inittab_active' }, "active" ),
			  &hlink( $text{ 'inittab_runlevels' }, "runlevels" ),
			  &hlink( $text{ 'inittab_action' }, "action" ),
			  &hlink( $text{ 'inittab_process' }, "process" ) ],
			100);
foreach $i (&parse_inittab()) {
	local @cols;
	push(@cols, "<a href='edit_inittab.cgi?id=$i->{'id'}'>".
		    &html_escape($i->{'id'})."</a>");
	push(@cols, $i->{'comment'} ? "<font color=#ff0000>$text{'no'}</font>"
				    : $text{'yes'});
	local @rls = @{$i->{'levels'}};
	push(@cols, @rls ? &html_escape(join(", ", @rls))
			 : $text{'inittab_none'});
	push(@cols, $text{"inittab_".$i->{'action'}} ||
		    "<tt>".&html_escape($i->{'action'})."</tt>");
	push(@cols, &html_escape($i->{'process'}));
	print &ui_columns_row(\@cols);
	}
print &ui_columns_end();
print "<a href=new_inittab.cgi>", $text{ 'inittab_new' }, "</a><p>\n";

print "<hr>\n";
print "<table width=100%><tr>\n";
print "<form action=apply.cgi>\n";
print "<td><input type=submit value='$text{'inittab_apply'}'></td>\n";
print "<td>$text{'inittab_applymsg'}</td>\n";
print "</form></tr></table><br>\n";

&ui_print_footer( "/", $text{'index'} );

