#!/usr/local/bin/perl
# edit_serv.cgi
# Edit or create a webmin server

require './servers-lib.pl';
&ReadParse();
$access{'edit'} || &error($text{'edit_ecannot'});

if ($in{'new'}) {
	&ui_print_header(undef, $text{'create_title'}, "");
	&get_miniserv_config(\%miniserv);
	$s = { 'port' => $miniserv{'port'},
	       'type' => $config{'auto_type'}, };
	}
else {
	&ui_print_header(undef, $text{'edit_title'}, "");
	$s = &get_server($in{'id'});
	&can_use_server($s) || &error($text{'edit_ecannot'});
	}

print &ui_form_start("save_serv.cgi");
print &ui_hidden("new", $in{'new'});
print &ui_hidden("id", $in{'id'});
print &ui_table_start($text{'edit_details'}, "width=100%", 4);

print &ui_table_row($text{'edit_host'},
		    &ui_textbox("host", $s->{'host'}, 30));

print &ui_table_row($text{'edit_port'},
		    &ui_textbox("port", $s->{'port'}, 5));

if ($s->{'realhost'}) {
	print &ui_table_row($text{'edit_realhost'},
			    "<tt>$s->{'realhost'}</tt>");
	}

if ($access{'forcetype'}) {
	print &ui_hidden("type", $s->{'type'});
	}
else {
	print &ui_table_row($text{'edit_type'},
			    &ui_select("type", $s->{'type'}, \@server_types));
	}

print &ui_table_row($text{'edit_ssl'},
		    &ui_yesno_radio("ssl", int($s->{'ssl'})));

print &ui_table_row($text{'edit_desc'},
    $config{'show_ip'} ?
	&ui_textbox("desc", $s->{'desc'}, 30, 0, 30) :
	&ui_opt_textbox("desc", $s->{'desc'}, 40, $text{'edit_desc_def'}), 3);

if ($access{'forcegroup'}) {
	# Cannot change group
	foreach $g (split(/\t/, $s->{'group'})) {
		print &ui_hidden("group", $g),"\n";
		}
	}
else {
	# Show group checkboxes, with option to add a new one
	@groups = &unique(map { split(/\t/, $_->{'group'}) } &list_servers());
	%ingroups = map { $_, 1 } split(/\t/, $s->{'group'});
	$gtable = "<table>\n";
	foreach $g (@groups) {
		$gtable .= "<tr>\n" if ($i%4 == 0);
		$gtable .= "<td width=25%>".
			   &ui_checkbox("group", $g, $g, $ingroups{$g})."</td>\n";
		$gtable .= "</tr>\n" if ($i++%4 == 3);
		}
	$gtable .= "</tr>\n" if ($i%4 != 0);
	$gtable .= "<tr>\n";
	$gtable .= "<td colspan=4>$text{'edit_new'} <input name=newgroup size=10></td>\n";
	$gtable .= "</tr>\n";
	$gtable .= "</table>\n";
	print &ui_table_row($text{'edit_group'}, $gtable, 3);
	}

$mode = $in{'new'} ? $config{'deflink'} :
	$s->{'autouser'} ? 2 :
	$s->{'sameuser'} ? 3 : $s->{'user'} ? 1 : 0;
if ($access{'forcelink'}) {
	print &ui_hidden("mode", $mode),"\n";
	if ($mode == 1) {
		print &ui_table_row($text{'edit_luser'},
				    &ui_textbox("user", $s->{'user'}, 10));
		print &ui_table_row($text{'edit_lpass'},
				    &ui_password("pass", $s->{'pass'}, 10));
		}
	}
else {
	# Login mode
	$linksel = &ui_radio("mode", $mode,
		[ [ 0, "$text{'edit_mode0'}<br>" ],
		  [ 1, $text{'edit_mode1'}." ".$text{'edit_user'}." ".
		       &ui_textbox("user", $mode == 1 ? $s->{'user'} : "", 10).
		       " ".$text{'edit_pass'}.
		       &ui_password("pass", $s->{'pass'}, 10)."<br>" ],
		  [ 2, "$text{'edit_mode2'}<br>" ],
		  ($access{'pass'} || $mode == 3 ?
		    ( [ 3, "$text{'edit_mode2'}<br>".
			   (defined($remote_pass) ? "" :
			    "<font size=-1>($text{'edit_same'})</font><br>") ] )
		    : ( ) ) ]);
	print &ui_table_row($text{'edit_link'}, $linksel, 3);
	}

if ($access{'forcefast'}) {
	# Don't allow choosing of fast mode
	print &ui_hidden("fast", $in{'new'} ? $config{'deffast'}
					    : $s->{'fast'});
	}
else {
	if ($in{'new'} || $s->{'fast'} == 2) {
		print &ui_table_row($text{'edit_fast'},
			&ui_radio("fast", $config{'deffast'},
				[ [ 1, $text{'yes'} ],
				  [ 2, $text{'edit_auto'} ],
				  [ 0, $text{'no'} ] ]));
		}
	else {
		print &ui_table_row($text{'edit_fast'},
			&ui_radio("fast", int($s->{'fast'}),
				[ [ 1, $text{'yes'} ],
				  [ 0, $text{'no'} ] ]));
		}
	print "</td> </tr>\n";
	}

if ($s->{'user'} && $config{'show_status'}) {
	sub status_error
	{
	$status_error_msg = join("", @_);
	}
	&remote_error_setup(\&status_error);
	eval {
		$SIG{'ALRM'} = sub { die "alarm\n" };
		alarm(10);
		&remote_foreign_require($s->{'host'}, "webmin","webmin-lib.pl");
		if ($status_error_msg) {
			# Failed to connect
			$msg = $status_error_msg;
			}
		else {
			# Connected - get status
			$msg = &text('edit_version',
				&remote_foreign_call($s->{'host'}, "webmin",
						     "get_webmin_version"));
			}
		alarm(0);
		};
	if ($@) {
		$msg = $text{'edit_timeout'};
		}

	print &ui_table_row($text{'edit_status'}, $msg, 3);
	}
print &ui_table_end();
print &ui_form_end([
	[ "save", $text{'save'} ],
	$in{'new'} ? ( ) : ( [ 'delete', $text{'delete'} ] ) ]);

&ui_print_footer("", $text{'index_return'});

